import random # Pour les tirages aleatoires
import pygame # Le module Pygame
import pygame.freetype # Pour afficher du texte
from math import sqrt
pygame.init() # initialisation de Pygame

# L'image de fond
largeur, hauteur = 800, 600

# On définit la taille de la fenêtre
screen = pygame.display.set_mode((largeur, hauteur))

# On met le nom de la fenêtre
pygame.display.set_caption("Clic moi si tu peux")

# On récupère l'image du smiley et on obtient sa taille
smiley = pygame.image.load("smiley.png").convert_alpha()
l_smiley, h_smiley = smiley.get_size()
rayon_initial = l_smiley

# Pour le texte
pygame.freetype.init()
police_normale = pygame.freetype.SysFont(None, 20)
police_grande = pygame.freetype.SysFont(None, 60)

# Pour controler le nombre d'images par seconde
clock = pygame.time.Clock()

def bouger_smiley():
    x_smiley = random.randint(rayon_initial, largeur-rayon_initial)
    y_smiley = random.randint(rayon_initial, hauteur-rayon_initial)
    return x_smiley, y_smiley

def afficher_texte(texte, point, couleur=(255, 255, 255), alignement="haut-gauche", police=police_normale):
    texte, rect = police.render(texte, couleur)
    if alignement == "haut-gauche":
        rect.topleft = point
    elif alignement == "haut":
        rect.top = point
    elif alignement == "haut-droite":
        rect.topright = point
    elif alignement == "droite":
        rect.right = point
    elif alignement == "bas-droite":
        rect.bottomright = point
    elif alignement == "bas":
        rect.bottom = point
    elif alignement == "bas-gauche":
        rect.bottomleft = point
    elif alignement == "gauche":
        rect.left = point
    elif alignement == "centre":
        rect.center = point
    screen.blit(texte, rect)

def afficher_image(image, point, alignement="haut-gauche", l=-1, h=-1):
    """
    Affiche l'image aux coordonnées indiquées par le point
    et l'alignement indiqués.
    Si l ou h valent autre chose que -1,
    l'image est redimensionnée.
    Si un des deux vaut -1, il est calculé
    pour garder le ratio de l'image.
    """
    l0, h0 = image.get_size()
    if (l, h) == (-1, -1):
        l, h = l0, h0
    elif l == -1 and h != -1:
        l = round(l0*h/h0)
        image = pygame.transform.smoothscale(image, (l, h))
    elif l != -1 and h == -1:
        h = round(h0*l/l0)
        image = pygame.transform.smoothscale(image, (l, h))
    else:
        image = pygame.transform.smoothscale(image, (l, h))
    if alignement == "haut-gauche":
        rect = image.get_rect(topleft=point)
    elif alignement == "haut":
        rect = image.get_rect(top=point)
    elif alignement == "haut-droite":
        rect = image.get_rect(topright=point)
    elif alignement == "droite":
        rect = image.get_rect(right=point)
    elif alignement == "bas-droite":
        rect = image.get_rect(bottomright=point)
    elif alignement == "bas":
        rect = image.get_rect(bottom=point)
    elif alignement == "bas-gauche":
        rect = image.get_rect(bottomleft=point)
    elif alignement == "gauche":
        rect = image.get_rect(left=point)
    elif alignement == "centre":
        rect = image.get_rect(center=point)
    screen.blit(image, rect)
        
def sur_smiley(x, y, x_smiley, y_smiley, r_smiley):
    return sqrt((x-x_smiley)**2+(y-y_smiley)**2) <= r_smiley

# Position de smiley
x_smiley, y_smiley = bouger_smiley()
r_smiley = rayon_initial
score = 0
continuer = True

etape = "menu"
horloge = 0

# Boucle principale
while continuer:
    # On remplit l'image de noir
    screen.fill((0, 0, 0))

    # Gestion des évènements
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            continuer = False  # Pour quitter
        elif event.type == pygame.MOUSEBUTTONDOWN: # Clic de souris
            x, y = pygame.mouse.get_pos() # coordonnees du pointeur de la souris
            if (sur_smiley(x, y, x_smiley, y_smiley, r_smiley)
                and etape == "jeu"):
                
                # On bouge le smiley
                x_smiley, y_smiley = bouger_smiley()
                r_smiley = rayon_initial
                score += 1
            elif horloge == 0:
                etape = "jeu"
                x_smiley, y_smiley = bouger_smiley()
                r_smiley = rayon_initial
                score = 0
    
    if etape == "jeu":
        afficher_texte(f"score : {score}", (20, 20), (255, 255, 255), "haut-gauche")
        afficher_image(smiley, (x_smiley, y_smiley), l=2*r_smiley, alignement="centre")
    elif etape == "gameover":
        afficher_texte(f"score : {score}", (20, 20), (255, 255, 255), "haut-gauche")
        afficher_texte("Game Over", (largeur//2, hauteur//2), (255, 255, 255), "centre", police_grande)
        if horloge > 0:
            horloge -= 1
    elif etape == "menu":
        afficher_texte("Cliquer pour jouer", (largeur//2, hauteur//2), (255, 255, 255), "centre", police_grande)
        
    
    # On affiche le resultat final à l'écran
    pygame.display.flip()
    # On attend le temps necessaire pour avoir un FPS constant
    clock.tick(30)

# On ferme la fenêtre
pygame.quit()

# rajouter top des meilleurs scores ?